#include <SFML/Graphics.hpp>
#include <iostream>


const int winW = 350; //  
const int winH = 350; //  

using namespace std;

int main() {
	sf::RenderWindow window(sf::VideoMode(winW, winH), "CMYK-CMYK-CMYK");

	sf::Color cl_c(0, 255, 255, 85); //Cyan
	sf::Color cl_m(255, 0, 255, 85); //Magenta
	sf::Color cl_y(255, 255, 0, 85); //Yellow

	int radius = 12; //  

	vector <sf::CircleShape> all_cir; //  
	
	for (int i = 0; i < 7; ++i) {
		for (int j = 0; j < 7; ++j) {
			//    ,  .
			sf::CircleShape c1(radius);
			c1.setPosition(sf::Vector2f(50*j, 50*i));
			c1.setFillColor(cl_y);
			all_cir.push_back(c1);

			sf::CircleShape c2(radius);
			c2.setPosition(sf::Vector2f(50 * j, 50 * i));
			c2.setFillColor(cl_m);
			all_cir.push_back(c2);

			sf::CircleShape c3(radius);
			c3.setPosition(sf::Vector2f(50 * j, 50 * i));
			c3.setFillColor(cl_c);
			all_cir.push_back(c3);
		}
	}



	bool back = 0;
	int distance = 30; // ,     
	while (1) {
		sf::Event event;
		while (window.pollEvent(event)) {
			//           Esc
			if (event.type == sf::Event::Closed || event.type == sf::Event::KeyPressed && event.key.code == sf::Keyboard::Escape)
				return 0;
		}

		window.clear(sf::Color::White); //  
		
		for (int i = 0; i < all_cir.size() - 2; i += 3) {
			if (i % 2 == 0) { //        
				if (!back) { 
					sf::Vector2f p = all_cir[i].getPosition();
					all_cir[i].setPosition(p.x, p.y + 0.5); //  
					p = all_cir[i + 1].getPosition();
					all_cir[i + 1].setPosition(p.x + 0.5, p.y - 0.5); //    
					p = all_cir[i + 2].getPosition();
					all_cir[i + 2].setPosition(p.x - 0.5, p.y - 0.5); //    
				}
				else { //    
					sf::Vector2f p = all_cir[i].getPosition();
					all_cir[i].setPosition(p.x, p.y - 0.5); //  
					p = all_cir[i + 1].getPosition();
					all_cir[i + 1].setPosition(p.x - 0.5, p.y + 0.5); //    
					p = all_cir[i + 2].getPosition();
					all_cir[i + 2].setPosition(p.x + 0.5, p.y + 0.5); //    
				}
				
			}
			else {
				if (!back) {
					sf::Vector2f p = all_cir[i].getPosition();
					all_cir[i].setPosition(p.x, p.y - 0.5); //  
					p = all_cir[i + 1].getPosition();
					all_cir[i + 1].setPosition(p.x - 0.5, p.y + 0.5); //    
					p = all_cir[i + 2].getPosition();
					all_cir[i + 2].setPosition(p.x + 0.5, p.y + 0.5); //    
				}
				else {
					sf::Vector2f p = all_cir[i].getPosition();
					all_cir[i].setPosition(p.x, p.y + 0.5);  //  
					p = all_cir[i + 1].getPosition();
					all_cir[i + 1].setPosition(p.x + 0.5, p.y - 0.5); //    
					p = all_cir[i + 2].getPosition();
					all_cir[i + 2].setPosition(p.x - 0.5, p.y - 0.5); //    
				}
			}
			
		}
		distance--;
		sf::sleep(sf::microseconds(12000)); //  ,    
		for (int i = 0; i < all_cir.size(); i++) //  
			window.draw(all_cir[i], sf::BlendMultiply); // sf::BlendMultiply -  
		window.display(); //  ,  .

		if (distance == 0) { //     ,   
			back = 1 - back;
			distance = 30;
		}
	}
}